function u=fem1d(coordinates,elements,dirichlet,neumann,a,b,c,f,u_d,u_n)

N=size(elements,1);
A=sparse(N+1,N+1);
B=sparse(N+1,N+1);
C=sparse(N+1,N+1);
rhs=zeros(N+1,1);
u=zeros(N+1,1);

% Aufstellen der Steifigkeitsmatrix
for j=1:N
  x=coordinates(elements(j,:));
  A(elements(j,:),elements(j,:))=A(elements(j,:),elements(j,:))+...
    a/(x(2)-x(1))*[1 -1;-1 1];
  B(elements(j,:),elements(j,:))=B(elements(j,:),elements(j,:))+...
    b/2*[-1 1;-1 1];
  C(elements(j,:),elements(j,:))=C(elements(j,:),elements(j,:))+...
    c*(x(2)-x(1))/6*[2 1;1 2];
end
% Rechte Seite
for j=1:N
  x=coordinates(elements(j,:));
  rhs([elements(j,1);elements(j,2)])=rhs([elements(j,1);elements(j,2)])+...
   (x(2)-x(1))/2*f((x(1)+x(2))/2);
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% HIER NEUMANN BEDINGUNG EINBAUEN
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% ...tbd...
%
disp('Neumann-Bedingungen einbauen!!!')
keyboard


% Dirichlet Bedingungen
u(dirichlet)=u_d;

% Berechnung der Loesung
%C=diag(sum(C'));
M=A+B+C;
freenodes=setdiff(1:size(elements,1)+1,dirichlet); 

rhs=rhs-M*u;

u(freenodes)=M(freenodes,freenodes)\rhs(freenodes);
